diff --git a/gcc/config/sparc/sparc.h b/gcc/config/sparc/sparc.h
index dd2b5ad..d41e8fc 100644
--- a/gcc/config/sparc/sparc.h
+++ b/gcc/config/sparc/sparc.h
@@ -791,7 +791,7 @@ extern int sparc_mode_class[];
    data references.  */
 
 #define PIC_OFFSET_TABLE_REGNUM \
-  (flag_pic ? GLOBAL_OFFSET_TABLE_REGNUM : INVALID_REGNUM)
+  (GCC_OPTION (flag_pic) ? GLOBAL_OFFSET_TABLE_REGNUM : INVALID_REGNUM)
 
 /* Pick a default value we can notice from override_options:
    !v9: Default is on.
@@ -1351,14 +1351,14 @@ do {									\
 #ifdef HAVE_AS_SPARC_UA_PCREL
 #ifdef HAVE_AS_SPARC_UA_PCREL_HIDDEN
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE,GLOBAL)			\
-  (flag_pic								\
+  (GCC_OPTION (flag_pic)								\
    ? (GLOBAL ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel | DW_EH_PE_sdata4\
    : ((TARGET_ARCH64 && ! GLOBAL)					\
       ? (DW_EH_PE_pcrel | DW_EH_PE_sdata4)				\
       : DW_EH_PE_absptr))
 #else
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE,GLOBAL)			\
-  (flag_pic								\
+  (GCC_OPTION (flag_pic)								\
    ? (GLOBAL ? DW_EH_PE_absptr : (DW_EH_PE_pcrel | DW_EH_PE_sdata4))	\
    : ((TARGET_ARCH64 && ! GLOBAL)					\
       ? (DW_EH_PE_pcrel | DW_EH_PE_sdata4)				\
@@ -1443,12 +1443,12 @@ do {									   \
    this has to be DImode in that case */
 #ifdef HAVE_GAS_SUBSECTION_ORDERING
 #define CASE_VECTOR_MODE \
-(! TARGET_PTR64 ? SImode : flag_pic ? SImode : TARGET_CM_MEDLOW ? SImode : DImode)
+(! TARGET_PTR64 ? SImode : GCC_OPTION (flag_pic) ? SImode : TARGET_CM_MEDLOW ? SImode : DImode)
 #else
 /* If assembler does not have working .subsection -1, we use DImode for pic, as otherwise
    we have to sign extend which slows things down.  */
 #define CASE_VECTOR_MODE \
-(! TARGET_PTR64 ? SImode : flag_pic ? DImode : TARGET_CM_MEDLOW ? SImode : DImode)
+(! TARGET_PTR64 ? SImode : GCC_OPTION (flag_pic) ? DImode : TARGET_CM_MEDLOW ? SImode : DImode)
 #endif
 
 /* Define this as 1 if `char' should by default be signed; else as 0.  */
@@ -1546,15 +1546,15 @@ do {									   \
    a taken branch costs 6 cycles.  */
 
 #define BRANCH_COST(speed_p, predictable_p) \
-	((sparc_cpu == PROCESSOR_V9 \
-	  || sparc_cpu == PROCESSOR_ULTRASPARC) \
+	((GCC_OPTION (sparc_cpu) == PROCESSOR_V9 \
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC) \
 	 ? 7 \
-         : (sparc_cpu == PROCESSOR_ULTRASPARC3 \
+         : (GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3 \
             ? 9 \
-	 : (sparc_cpu == PROCESSOR_NIAGARA \
+	 : (GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA \
 	    ? 4 \
-	 : ((sparc_cpu == PROCESSOR_NIAGARA2 \
-	     || sparc_cpu == PROCESSOR_NIAGARA3) \
+	 : ((GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2 \
+	     || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3) \
 	    ? 5 \
 	 : 3))))
 
@@ -1771,7 +1771,7 @@ extern int sparc_indent_opcode;
 #define MASK_DEBUG_OPTIONS		0x01	/* debug option handling */
 #define MASK_DEBUG_ALL			MASK_DEBUG_OPTIONS
 
-#define TARGET_DEBUG_OPTIONS		(sparc_debug & MASK_DEBUG_OPTIONS)
+#define TARGET_DEBUG_OPTIONS		(GCC_OPTION (sparc_debug) & MASK_DEBUG_OPTIONS)
 
 /* By default, use the weakest memory model for the cpu.  */
 #ifndef SUBTARGET_DEFAULT_MEMORY_MODEL
diff --git a/gcc/config/spu/spu-c.c b/gcc/config/spu/spu-c.c
index 9d7aa5a..4296030 100644
--- a/gcc/config/spu/spu-c.c
+++ b/gcc/config/spu/spu-c.c
@@ -101,7 +101,7 @@ spu_resolve_overloaded_builtin (location_t loc, tree fndecl, void *passed_args)
   tree match = NULL_TREE;
 
   /* The vector types are not available if the backend is not initialized.  */
-  gcc_assert (!flag_preprocess_only);
+  gcc_assert (!GCC_OPTION (flag_preprocess_only));
 
   desc = &spu_builtins[fcode];
   if (desc->type != B_OVERLOAD)
@@ -195,7 +195,7 @@ spu_cpu_cpp_builtins (struct cpp_reader *pfile)
   if (spu_arch == PROCESSOR_CELLEDP)
     cpp_define (pfile, "__SPU_EDP__");
   cpp_define (pfile, "__vector=__attribute__((__spu_vector__))");
-  switch (spu_ea_model)
+  switch (GCC_OPTION (spu_ea_model))
     {
     case 32:
       cpp_define (pfile, "__EA32__");
@@ -230,6 +230,6 @@ spu_c_common_override_options (void)
   if (!TARGET_STD_MAIN)
     {
       /* Don't give warnings about the main() function.  */
-      warn_main = 0;
+      GCC_OPTION (warn_main) = 0;
     }
 }
diff --git a/gcc/config/spu/spu.c b/gcc/config/spu/spu.c
index 302d7e0..b7480b7 100644
--- a/gcc/config/spu/spu.c
+++ b/gcc/config/spu/spu.c
@@ -209,7 +209,7 @@ static enum immediate_class classify_immediate (rtx op,
 						enum machine_mode mode);
 
 /* Pointer mode for __ea references.  */
-#define EAmode (spu_ea_model != 32 ? DImode : SImode)
+#define EAmode (GCC_OPTION (spu_ea_model) != 32 ? DImode : SImode)
 
 
 /* Define the structure for the machine field in struct function.  */
@@ -235,44 +235,44 @@ spu_option_override (void)
 
   /* Small loops will be unpeeled at -O3.  For SPU it is more important
      to keep code small by default.  */
-  if (!flag_unroll_loops && !flag_peel_loops)
+  if (!GCC_OPTION (flag_unroll_loops) && !GCC_OPTION (flag_peel_loops))
     maybe_set_param_value (PARAM_MAX_COMPLETELY_PEEL_TIMES, 4,
 			   global_options.x_param_values,
 			   global_options_set.x_param_values);
 
-  flag_omit_frame_pointer = 1;
+  GCC_OPTION (flag_omit_frame_pointer) = 1;
 
   /* Functions must be 8 byte aligned so we correctly handle dual issue */
-  if (align_functions < 8)
-    align_functions = 8;
+  if (GCC_OPTION (align_functions) < 8)
+    GCC_OPTION (align_functions) = 8;
 
-  spu_hint_dist = 8*4 - spu_max_nops*4;
+  spu_hint_dist = 8*4 - GCC_OPTION (spu_max_nops)*4;
   if (spu_hint_dist < 0) 
     spu_hint_dist = 0;
 
-  if (spu_fixed_range_string)
-    fix_range (spu_fixed_range_string);
+  if (GCC_OPTION (spu_fixed_range_string))
+    fix_range (GCC_OPTION (spu_fixed_range_string));
 
   /* Determine processor architectural level.  */
-  if (spu_arch_string)
+  if (GCC_OPTION (spu_arch_string))
     {
-      if (strcmp (&spu_arch_string[0], "cell") == 0)
+      if (strcmp (&GCC_OPTION (spu_arch_string)[0], "cell") == 0)
         spu_arch = PROCESSOR_CELL;
-      else if (strcmp (&spu_arch_string[0], "celledp") == 0)
+      else if (strcmp (&GCC_OPTION (spu_arch_string)[0], "celledp") == 0)
         spu_arch = PROCESSOR_CELLEDP;
       else
-        error ("bad value (%s) for -march= switch", spu_arch_string);
+        error ("bad value (%s) for -march= switch", GCC_OPTION (spu_arch_string));
     }
 
   /* Determine processor to tune for.  */
-  if (spu_tune_string)
+  if (GCC_OPTION (spu_tune_string))
     {
-      if (strcmp (&spu_tune_string[0], "cell") == 0)
+      if (strcmp (&GCC_OPTION (spu_tune_string)[0], "cell") == 0)
         spu_tune = PROCESSOR_CELL;
-      else if (strcmp (&spu_tune_string[0], "celledp") == 0)
+      else if (strcmp (&GCC_OPTION (spu_tune_string)[0], "celledp") == 0)
         spu_tune = PROCESSOR_CELLEDP;
       else
-        error ("bad value (%s) for -mtune= switch", spu_tune_string);
+        error ("bad value (%s) for -mtune= switch", GCC_OPTION (spu_tune_string));
     }
 
   /* Change defaults according to the processor architecture.  */
@@ -282,7 +282,7 @@ spu_option_override (void)
 	 the default to -mno-safe-hints on celledp -- only the original
 	 Cell/B.E. processors require this workaround.  */
       if (!(target_flags_explicit & MASK_SAFE_HINTS))
-	target_flags &= ~MASK_SAFE_HINTS;
+	GCC_OPTION (target_flags) &= ~MASK_SAFE_HINTS;
     }
 
   REAL_MODE_FORMAT (SFmode) = &spu_single_format;
@@ -1582,14 +1582,14 @@ spu_split_immediate (rtx * ops)
 	      emit_move_insn (ops[0], gen_rtx_HIGH (mode, ops[1]));
 	      emit_move_insn (ops[0], gen_rtx_LO_SUM (mode, ops[0], ops[1]));
 	    }
-	  else if (flag_pic)
+	  else if (GCC_OPTION (flag_pic))
 	    emit_insn (gen_pic (ops[0], ops[1]));
-	  if (flag_pic)
+	  if (GCC_OPTION (flag_pic))
 	    {
 	      rtx pic_reg = get_pic_reg ();
 	      emit_insn (gen_addsi3 (ops[0], ops[0], pic_reg));
 	    }
-	  return flag_pic || c == IC_IL2s;
+	  return GCC_OPTION (flag_pic) || c == IC_IL2s;
 	}
       break;
     case IC_IL1:
@@ -1611,7 +1611,7 @@ need_to_save_reg (int regno, int saving)
 {
   if (df_regs_ever_live_p (regno) && !call_used_regs[regno])
     return 1;
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && regno == PIC_OFFSET_TABLE_REGNUM
       && (!saving || cfun->machine->pic_reg == pic_offset_table_rtx))
     return 1;
@@ -1727,7 +1727,7 @@ spu_expand_prologue (void)
   rtx scratch_reg_0, scratch_reg_1;
   rtx insn, real;
 
-  if (flag_pic && optimize == 0 && !cfun->machine->pic_reg)
+  if (GCC_OPTION (flag_pic) && GCC_OPTION (optimize) == 0 && !cfun->machine->pic_reg)
     cfun->machine->pic_reg = pic_offset_table_rtx;
 
   if (spu_naked_function_p (current_function_decl))
@@ -1765,7 +1765,7 @@ spu_expand_prologue (void)
 	  }
     }
 
-  if (flag_pic && cfun->machine->pic_reg)
+  if (GCC_OPTION (flag_pic) && cfun->machine->pic_reg)
     {
       rtx pic_reg = cfun->machine->pic_reg;
       insn = emit_insn (gen_load_pic_offset (pic_reg, scratch_reg_0));
@@ -1774,7 +1774,7 @@ spu_expand_prologue (void)
 
   if (total_size > 0)
     {
-      if (flag_stack_check)
+      if (GCC_OPTION (flag_stack_check))
 	{
 	  /* We compare against total_size-1 because
 	     ($sp >= total_size) <=> ($sp > total_size-1) */
@@ -1832,7 +1832,7 @@ spu_expand_prologue (void)
 	}
     }
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = total_size;
 }
 
@@ -2434,7 +2434,7 @@ static int in_spu_reorg;
 static void
 spu_var_tracking (void)
 {
-  if (flag_var_tracking)
+  if (GCC_OPTION (flag_var_tracking))
     {
       df_analyze ();
       timevar_push (TV_VAR_TRACKING);
@@ -2457,7 +2457,7 @@ spu_machine_dependent_reorg (void)
   int i;
   unsigned int j;
 
-  if (!TARGET_BRANCH_HINTS || optimize == 0)
+  if (!TARGET_BRANCH_HINTS || GCC_OPTION (optimize) == 0)
     {
       /* We still do it for unoptimized code because an external
          function might have hinted a call or return. */
@@ -2782,7 +2782,7 @@ static void
 spu_sched_init (FILE *file ATTRIBUTE_UNUSED, int verbose ATTRIBUTE_UNUSED,
 		int max_ready ATTRIBUTE_UNUSED)
 {
-  if (align_labels > 4 || align_loops > 4 || align_jumps > 4)
+  if (GCC_OPTION (align_labels) > 4 || GCC_OPTION (align_loops) > 4 || GCC_OPTION (align_jumps) > 4)
     {
       /* When any block might be at least 8-byte aligned, assume they
          will all be at least 8-byte aligned to make sure dual issue
@@ -2954,23 +2954,23 @@ spu_sched_reorder (FILE *file ATTRIBUTE_UNUSED, int verbose ATTRIBUTE_UNUSED,
      without effecting the critical path.  We look at INSN_PRIORITY to
      make a good guess, but it isn't perfect so -mdual-nops=n can be
      used to effect it. */
-  if (in_spu_reorg && spu_dual_nops < 10)
+  if (in_spu_reorg && GCC_OPTION (spu_dual_nops) < 10)
     {
       /* When we are at an even address and we are not issuing nops to
          improve scheduling then we need to advance the cycle.  */
       if ((spu_sched_length & 7) == 0 && prev_clock_var == clock
-	  && (spu_dual_nops == 0
+	  && (GCC_OPTION (spu_dual_nops) == 0
 	      || (pipe_1 != -1
 		  && prev_priority >
-		  INSN_PRIORITY (ready[pipe_1]) + spu_dual_nops)))
+		  INSN_PRIORITY (ready[pipe_1]) + GCC_OPTION (spu_dual_nops))))
 	return 0;
 
       /* When at an odd address, schedule the highest priority insn
          without considering pipeline. */
       if ((spu_sched_length & 7) == 4 && prev_clock_var != clock
-	  && (spu_dual_nops == 0
+	  && (GCC_OPTION (spu_dual_nops) == 0
 	      || (prev_priority >
-		  INSN_PRIORITY (ready[nready - 1]) + spu_dual_nops)))
+		  INSN_PRIORITY (ready[nready - 1]) + GCC_OPTION (spu_dual_nops))))
 	return 1;
     }
 
@@ -3176,7 +3176,7 @@ classify_immediate (rtx op, enum machine_mode mode)
     mode = GET_MODE (op);
 
   /* A V4SI const_vector with all identical symbols is ok. */
-  if (!flag_pic
+  if (!GCC_OPTION (flag_pic)
       && mode == V4SImode
       && GET_CODE (op) == CONST_VECTOR
       && GET_CODE (CONST_VECTOR_ELT (op, 0)) != CONST_INT
@@ -3500,7 +3500,7 @@ spu_legitimate_constant_p (enum machine_mode mode, rtx x)
     return 0;
 
   /* V4SI with all identical symbols is valid. */
-  if (!flag_pic
+  if (!GCC_OPTION (flag_pic)
       && mode == V4SImode
       && (GET_CODE (CONST_VECTOR_ELT (x, 0)) == SYMBOL_REF
 	  || GET_CODE (CONST_VECTOR_ELT (x, 0)) == LABEL_REF
@@ -3951,12 +3951,12 @@ spu_build_builtin_va_list (void)
 
   /* We know this is being padded and we want it too.  It is an internal
      type so hide the warnings from the user. */
-  owp = warn_padded;
-  warn_padded = false;
+  owp = GCC_OPTION (warn_padded);
+  GCC_OPTION (warn_padded) = false;
 
   layout_type (record);
 
-  warn_padded = owp;
+  GCC_OPTION (warn_padded) = owp;
 
   /* The correct type is an array type of one element.  */
   return build_array_type (record, build_index_type (size_zero_node));
@@ -4117,7 +4117,7 @@ spu_setup_incoming_varargs (cumulative_args_t cum, enum machine_mode mode,
 static void
 spu_conditional_register_usage (void)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fixed_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
       call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
@@ -4274,7 +4274,7 @@ ea_load_store_inline (rtx mem, bool is_store, rtx ea_addr, rtx data_addr)
   rtx eq_index = gen_reg_rtx (SImode);
   rtx bcomp, hit_label, hit_ref, cont_label, insn;
 
-  if (spu_ea_model != 32)
+  if (GCC_OPTION (spu_ea_model) != 32)
     {
       splat_hi = gen_reg_rtx (V4SImode);
       cache_tag_hi = gen_reg_rtx (V4SImode);
@@ -4286,7 +4286,7 @@ ea_load_store_inline (rtx mem, bool is_store, rtx ea_addr, rtx data_addr)
   v = 0x0001020300010203LL;
   emit_move_insn (splat_mask, immed_double_const (v, v, TImode));
   ea_addr_si = ea_addr;
-  if (spu_ea_model != 32)
+  if (GCC_OPTION (spu_ea_model) != 32)
     ea_addr_si = convert_to_mode (SImode, ea_addr, 1);
 
   /* tag_index = ea_addr & (tag_array_size - 128)  */
@@ -4295,7 +4295,7 @@ ea_load_store_inline (rtx mem, bool is_store, rtx ea_addr, rtx data_addr)
   /* splat ea_addr to all 4 slots.  */
   emit_insn (gen_shufb (splat, ea_addr_si, ea_addr_si, splat_mask));
   /* Similarly for high 32 bits of ea_addr.  */
-  if (spu_ea_model != 32)
+  if (GCC_OPTION (spu_ea_model) != 32)
     emit_insn (gen_shufb (splat_hi, ea_addr, ea_addr, splat_mask));
 
   /* block_off = ea_addr & 127  */
@@ -4306,7 +4306,7 @@ ea_load_store_inline (rtx mem, bool is_store, rtx ea_addr, rtx data_addr)
 
   /* Read cache tags.  */
   emit_move_insn (cache_tag, gen_rtx_MEM (V4SImode, tag_addr));
-  if (spu_ea_model != 32)
+  if (GCC_OPTION (spu_ea_model) != 32)
     emit_move_insn (cache_tag_hi, gen_rtx_MEM (V4SImode,
 					       plus_constant (Pmode,
 							      tag_addr, 16)));
@@ -4321,7 +4321,7 @@ ea_load_store_inline (rtx mem, bool is_store, rtx ea_addr, rtx data_addr)
 
   /* Compare tags.  */
   emit_insn (gen_ceq_v4si (tag_equal, tag, cache_tag));
-  if (spu_ea_model != 32)
+  if (GCC_OPTION (spu_ea_model) != 32)
     {
       emit_insn (gen_ceq_v4si (tag_equal_hi, splat_hi, cache_tag_hi));
       emit_insn (gen_andv4si3 (tag_equal, tag_equal, tag_equal_hi));
@@ -4414,7 +4414,7 @@ expand_ea_mem (rtx mem, bool is_store)
   rtx new_mem;
 
   ea_addr = force_reg (EAmode, XEXP (mem, 0));
-  if (optimize_size || optimize == 0)
+  if (GCC_OPTION (optimize_size) || GCC_OPTION (optimize) == 0)
     ea_load_store (mem, is_store, ea_addr, data_addr);
   else
     ea_load_store_inline (mem, is_store, ea_addr, data_addr);
@@ -5164,7 +5164,7 @@ static void
 reloc_diagnostic (rtx x)
 {
   tree decl = 0;
-  if (!flag_pic || !(TARGET_WARN_RELOC || TARGET_ERROR_RELOC))
+  if (!GCC_OPTION (flag_pic) || !(TARGET_WARN_RELOC || TARGET_ERROR_RELOC))
     return;
 
   if (GET_CODE (x) == SYMBOL_REF)
@@ -5383,7 +5383,7 @@ spu_allocate_stack (rtx op0, rtx op1)
   emit_insn (gen_spu_convert (sp, stack_pointer_rtx));
   emit_insn (gen_subv4si3 (sp, sp, splatted));
 
-  if (flag_stack_check)
+  if (GCC_OPTION (flag_stack_check))
     {
       rtx avail = gen_reg_rtx(SImode);
       rtx result = gen_reg_rtx(SImode);
@@ -6668,7 +6668,7 @@ spu_add_stmt_cost (void *data, int count, enum vect_cost_for_stmt kind,
   unsigned *cost = (unsigned *) data;
   unsigned retval = 0;
 
-  if (flag_vect_cost_model)
+  if (GCC_OPTION (flag_vect_cost_model))
     {
       tree vectype = stmt_info ? stmt_vectype (stmt_info) : NULL_TREE;
       int stmt_cost = spu_builtin_vectorization_cost (kind, vectype, misalign);
diff --git a/gcc/config/spu/spu.h b/gcc/config/spu/spu.h
index ac05f4c..05b6f5c 100644
--- a/gcc/config/spu/spu.h
+++ b/gcc/config/spu/spu.h
@@ -108,7 +108,7 @@ extern GTY(()) int spu_tune;
 	(GET_CODE (X) == SYMBOL_REF \
           && (SYMBOL_REF_FLAGS (X) & SYMBOL_FLAG_ALIGN1) == 0 \
 	  && (! SYMBOL_REF_FUNCTION_P (X) \
-	      || align_functions >= 16))
+	      || GCC_OPTION (align_functions) >= 16))
 
 #define PCC_BITFIELD_TYPE_MATTERS 1
 
@@ -401,7 +401,7 @@ do {									\
 
 /* Costs */
 
-#define BRANCH_COST(speed_p, predictable_p) spu_branch_cost
+#define BRANCH_COST(speed_p, predictable_p) GCC_OPTION (spu_branch_cost)
 
 #define SLOW_BYTE_ACCESS 0
 
diff --git a/gcc/config/stormy16/stormy16.c b/gcc/config/stormy16/stormy16.c
index 6a64fcc..2a4b332 100644
--- a/gcc/config/stormy16/stormy16.c
+++ b/gcc/config/stormy16/stormy16.c
@@ -1052,7 +1052,7 @@ xstormy16_expand_prologue (void)
   if (layout.locals_size >= 32768)
     error ("local variable memory requirements exceed capacity");
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = layout.frame_size;
 
   /* Save the argument registers if necessary.  */
diff --git a/gcc/config/tilegx/tilegx.c b/gcc/config/tilegx/tilegx.c
index c3b7126..9fabae2 100644
--- a/gcc/config/tilegx/tilegx.c
+++ b/gcc/config/tilegx/tilegx.c
@@ -85,18 +85,18 @@ tilegx_option_override (void)
 {
   if (global_options_set.x_tilegx_cmodel)
     {
-      switch (tilegx_cmodel)
+      switch (GCC_OPTION (tilegx_cmodel))
 	{
 	case CM_SMALL:
 	case CM_SMALL_PIC:
-	  if (flag_pic)
-	    tilegx_cmodel = CM_SMALL_PIC;
+	  if (GCC_OPTION (flag_pic))
+	    GCC_OPTION (tilegx_cmodel) = CM_SMALL_PIC;
 	  break;
 
 	case CM_LARGE:
 	case CM_LARGE_PIC:
-	  if (flag_pic)
-	    tilegx_cmodel = CM_LARGE_PIC;
+	  if (GCC_OPTION (flag_pic))
+	    GCC_OPTION (tilegx_cmodel) = CM_LARGE_PIC;
 	  break;
 
 	default:
@@ -104,12 +104,12 @@ tilegx_option_override (void)
 	}
     }
   else
-    tilegx_cmodel = flag_pic ? CM_SMALL_PIC : CM_SMALL;
+    GCC_OPTION (tilegx_cmodel) = GCC_OPTION (flag_pic) ? CM_SMALL_PIC : CM_SMALL;
 
   /* When modulo scheduling is enabled, we still rely on regular
      scheduler for bundling.  */
-  if (flag_modulo_sched)
-    flag_resched_modulo_sched = 1;
+  if (GCC_OPTION (flag_modulo_sched))
+    GCC_OPTION (flag_resched_modulo_sched) = 1;
 }
 
 
@@ -158,7 +158,7 @@ tilegx_cannot_force_const_mem (enum machine_mode mode ATTRIBUTE_UNUSED,
 static bool
 tilegx_function_ok_for_sibcall (tree decl, tree exp ATTRIBUTE_UNUSED)
 {
-  return (tilegx_cmodel != CM_LARGE && tilegx_cmodel != CM_LARGE_PIC
+  return (GCC_OPTION (tilegx_cmodel) != CM_LARGE && GCC_OPTION (tilegx_cmodel) != CM_LARGE_PIC
 	  && (decl != NULL));
 }
 
@@ -346,12 +346,12 @@ tilegx_build_builtin_va_list (void)
 
   /* We know this is being padded and we want it too.  It is an
      internal type so hide the warnings from the user.  */
-  owp = warn_padded;
-  warn_padded = false;
+  owp = GCC_OPTION (warn_padded);
+  GCC_OPTION (warn_padded) = false;
 
   layout_type (record);
 
-  warn_padded = owp;
+  GCC_OPTION (warn_padded) = owp;
 
   /* The correct type is an array type of one element.  */
   return record;
@@ -747,7 +747,7 @@ tilegx_init_expanders (void)
      status.  */
   init_machine_status = tilegx_init_machine_status;
 
-  if (cfun && cfun->machine && flag_pic)
+  if (cfun && cfun->machine && GCC_OPTION (flag_pic))
     {
       static int label_num = 0;
 
@@ -968,7 +968,7 @@ static rtx
 tilegx_tls_got (void)
 {
   rtx temp;
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       crtl->uses_pic_offset_table = 1;
       return tilegx_got_rtx ();
@@ -1144,7 +1144,7 @@ tilegx_compute_pcrel_address (rtx result, rtx addr)
 					    text_label_rtx,
 					    addr, text_label_symbol));
     }
-  else if (tilegx_cmodel == CM_LARGE_PIC)
+  else if (GCC_OPTION (tilegx_cmodel) == CM_LARGE_PIC)
     {
       temp3 = create_temp_reg_if_possible (Pmode, result);
       emit_insn (gen_mov_large_pcrel_step1 (temp, addr, text_label_symbol));
@@ -1247,8 +1247,8 @@ tilegx_legitimize_pic_address (rtx orig,
 	     optimized properly.  */
 	  rtx temp_reg = create_temp_reg_if_possible (Pmode, reg);
 
-	  gcc_assert (flag_pic);
-	  if (flag_pic == 1)
+	  gcc_assert (GCC_OPTION (flag_pic));
+	  if (GCC_OPTION (flag_pic) == 1)
 	    {
 	      if (TARGET_32BIT)
 		{
@@ -1371,7 +1371,7 @@ tilegx_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
     {
       return tilegx_legitimize_tls_address (x);
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
       return tilegx_legitimize_pic_address (x, mode, 0);
     }
@@ -1427,12 +1427,12 @@ tilegx_delegitimize_address (rtx x)
 static void
 load_pic_register (bool delay_pic_helper ATTRIBUTE_UNUSED)
 {
-  int orig_flag_pic = flag_pic;
+  int orig_flag_pic = GCC_OPTION (flag_pic);
 
   rtx got_symbol = tilegx_got_symbol ();
   rtx text_label_symbol = tilegx_text_label_symbol ();
   rtx text_label_rtx = tilegx_text_label_rtx ();
-  flag_pic = 0;
+  GCC_OPTION (flag_pic) = 0;
 
   if (TARGET_32BIT)
     {
@@ -1446,7 +1446,7 @@ load_pic_register (bool delay_pic_helper ATTRIBUTE_UNUSED)
 
   tilegx_compute_pcrel_address (tilegx_got_rtx (), got_symbol);
 
-  flag_pic = orig_flag_pic;
+  GCC_OPTION (flag_pic) = orig_flag_pic;
 
   /* Need to emit this whether or not we obey regdecls, since
      setjmp/longjmp can cause life info to screw up.  ??? In the case
@@ -1828,7 +1828,7 @@ tilegx_expand_mov (enum machine_mode mode, rtx *operands)
     }
 
   /* Fixup PIC cases.  */
-  if (flag_pic && CONSTANT_P (operands[1]))
+  if (GCC_OPTION (flag_pic) && CONSTANT_P (operands[1]))
     {
       if (tilegx_pic_address_needs_scratch (operands[1]))
 	operands[1] = tilegx_legitimize_pic_address (operands[1], mode, 0);
@@ -2747,7 +2747,7 @@ tilegx_output_cbranch (rtx insn, rtx *operands, bool reversed)
 void
 tilegx_expand_tablejump (rtx op0, rtx op1)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       rtx temp = gen_reg_rtx (Pmode);
       rtx temp2 = gen_reg_rtx (Pmode);
@@ -3676,7 +3676,7 @@ need_to_save_reg (unsigned int regno)
       && df_regs_ever_live_p (regno))
     return true;
 
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && (regno == PIC_OFFSET_TABLE_REGNUM
 	  || regno == TILEGX_PIC_TEXT_LABEL_REGNUM)
       && (crtl->uses_pic_offset_table || crtl->saves_all_registers))
@@ -3997,7 +3997,7 @@ tilegx_expand_prologue (void)
 
   int total_size = compute_total_frame_size ();
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = total_size;
 
   /* Save lr first in its special location because code after this
@@ -4009,7 +4009,7 @@ tilegx_expand_prologue (void)
   if (total_size == 0)
     {
       /* Load the PIC register if needed.  */
-      if (flag_pic && crtl->uses_pic_offset_table)
+      if (GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
 	load_pic_register (false);
 
       return;
@@ -4131,7 +4131,7 @@ tilegx_expand_prologue (void)
     emit_insn (gen_blockage ());
 
   /* Load the PIC register if needed.  */
-  if (flag_pic && crtl->uses_pic_offset_table)
+  if (GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
     load_pic_register (false);
 }
 
@@ -4266,7 +4266,7 @@ tilegx_expand_epilogue (bool sibcall_p)
     }
 
   /* Mark the pic registers as live outside of the function.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       emit_use (cfun->machine->text_label_rtx);
       emit_use (cfun->machine->got_rtx);
@@ -4572,7 +4572,7 @@ replace_mov_pcrel_step1 (rtx insn)
 
   start_sequence ();
 
-  if (flag_pic != 1)
+  if (GCC_OPTION (flag_pic) != 1)
     {
       if (TARGET_32BIT)
 	emit_insn (gen_mov_got32_step1_32bit (opnds[0], opnds[1]));
@@ -4649,7 +4649,7 @@ replace_mov_pcrel_step2 (rtx insn)
 
   start_sequence ();
 
-  if (flag_pic == 1)
+  if (GCC_OPTION (flag_pic) == 1)
     {
       if (TARGET_32BIT)
 	emit_insn (gen_add_got16_32bit (opnds[0], got_rtx, opnds[2]));
@@ -4708,7 +4708,7 @@ replace_mov_pcrel_step3 (rtx insn)
 
   start_sequence ();
 
-  if (flag_pic == 1)
+  if (GCC_OPTION (flag_pic) == 1)
     {
       emit_move_insn (opnds[0], gen_const_mem (Pmode, opnds[2]));
     }
@@ -4864,12 +4864,12 @@ tilegx_reorg (void)
      now.  */
   compute_bb_for_insn ();
 
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
       tilegx_fixup_pcrel_references ();
     }
 
-  if (flag_schedule_insns_after_reload)
+  if (GCC_OPTION (flag_schedule_insns_after_reload))
     {
       split_all_insns ();
 
@@ -4883,7 +4883,7 @@ tilegx_reorg (void)
 
   df_analyze ();
 
-  if (flag_var_tracking)
+  if (GCC_OPTION (flag_var_tracking))
     {
       timevar_push (TV_VAR_TRACKING);
       variable_tracking_main ();
@@ -5370,10 +5370,10 @@ tilegx_print_operand (FILE *file, rtx x, int code)
     case 'p':
       if (GET_CODE (x) == SYMBOL_REF)
 	{
-	  if (flag_pic && !SYMBOL_REF_LOCAL_P (x))
+	  if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (x))
 	    fprintf (file, "plt(");
 	  output_addr_const (file, x);
-	  if (flag_pic && !SYMBOL_REF_LOCAL_P (x))
+	  if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (x))
 	    fprintf (file, ")");
 	}
       else
@@ -5517,7 +5517,7 @@ tilegx_function_profiler (FILE *file, int labelno ATTRIBUTE_UNUSED)
       fprintf (file, "\t}\n");
     }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fprintf (file,
 	       "\t{\n"
diff --git a/gcc/config/tilegx/tilegx.h b/gcc/config/tilegx/tilegx.h
index f241fe4..d832396 100644
--- a/gcc/config/tilegx/tilegx.h
+++ b/gcc/config/tilegx/tilegx.h
@@ -168,8 +168,8 @@
 
 /* Register that holds an address into the text segment that can be
    used by pic code.  */
-#define TILEGX_PIC_TEXT_LABEL_REGNUM (flag_pic ? 50 : INVALID_REGNUM)
-#define PIC_OFFSET_TABLE_REGNUM (flag_pic ? 51 : INVALID_REGNUM)
+#define TILEGX_PIC_TEXT_LABEL_REGNUM (GCC_OPTION (flag_pic) ? 50 : INVALID_REGNUM)
+#define PIC_OFFSET_TABLE_REGNUM (GCC_OPTION (flag_pic) ? 51 : INVALID_REGNUM)
 #define HARD_FRAME_POINTER_REGNUM 52
 #define THREAD_POINTER_REGNUM 53
 #define STACK_POINTER_REGNUM 54
